define([
    "dojo/_base/declare",
    "dojox/mvc/at",
    "aps/Memory",
    "aps/_View",
    "aps/_typeInfo"
], function (declare, at, Memory, _View, APSTypes) {
    return declare(_View, {
        init: function () {
            return [
                ["aps/FieldSet", {
                    id: this.genId("container-description")
                }, [
                    ["aps/Output", {
                        id: this.genId("description"),
                        value: "Lorem ipsum dolor sit amet, consectetur adipiscing elit."
                    }]
                ]],
                ["aps/Tiles", {
                    id: this.genId("panels"),
                    store: new Memory({
                        data: [],
                        idProperty: "aps.service.presentation.name"
                    })
                }, [
                    ["aps/Tile", {
                        title: at("rel:aps.service.presentation", "name")
                    }, [
                        ["aps/Output", {
                            content: "Service description = ${dat}",
                            dat: at("rel:aps.service.presentation", "summary")
                        }],
                        ["aps/Output", {
                            content: "Link = <a href='https://kb.odin.com' target='_blank'>https://kb.odin.com</a>"
                        }]
                    ]]
                ]]
            ];
        },
        onContext: function () {
            var services = aps.context.vars.services;
            var apsTypes = services.map(function (s) {
                return s.aps.type
            });
            var self = this;
            APSTypes._getServicesByAPSTypes(apsTypes).then(function (result) {
                var panels = self.byId("panels");
                panels.get("store").data = services.map(function(service){ return result[service.aps.type]; });
                panels.refresh();

                aps.apsc.hideLoading();
            });
        }
    });
});